﻿
using System;
using System.ComponentModel;
using System.Threading;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejWebPageApplication1
{
	public partial class Page1 : Page
	{
		Thread thread;
		
		public Data Data { get; set; }
		public Page1()
		{
			InitializeComponent();
			Data = new Data();
			Data.Label = textBox1.Label;
			textBox1.DataBindings.Add(new Binding("Text", Data, "Value"));
			textBox1.DataBindings.Add(new Binding("Label", Data, "Label"));

			thread = new Thread(ExecuteThread);

		}

        private async void ExecuteThread()
        {
			while (true)
            {
				await Task.Delay(1500);
				Application.Update(this, () =>
				{
					 Data.Label.Text = Guid.NewGuid().ToString();
					Data.Value = Guid.NewGuid().ToString();
				});
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
			thread.Start();
			button1.Enabled = false;
        }
    }

    public class Data: INotifyPropertyChanged
    {

		protected void OnPropertyChanged(PropertyChangedEventArgs e)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null)
				handler(this, e);
		}

		protected void OnPropertyChanged(string propertyName)
		{
			OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
		}

		private string _value;
		public string Value
		{
			get { return _value; }
			set
            {
				_value = value;
				OnPropertyChanged(new PropertyChangedEventArgs(nameof(Value)));
            }
		}


		private LabelWrapper _Label;
		public LabelWrapper Label
		{
			get { return _Label; }
			set
            {
				_Label = value;
				OnPropertyChanged(new PropertyChangedEventArgs(nameof(Label)));
            }
		}

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
